import { Command, flags } from '@oclif/command';
interface NetworkInfo {
    url: string;
    id?: number;
    label?: string;
}
declare type NetworkFlag = keyof typeof BaseCommand.flags;
declare type NetworkName = Exclude<NetworkFlag, 'url'>;
export declare abstract class BaseCommand extends Command {
    static flags: {
        url: flags.IOptionFlag<string | undefined>;
        mainnet: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        ropsten: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        rinkeby: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        rsk: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        'rsk-testnet': import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        kovan: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        sokol: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        poa: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        xdai: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
    };
    static defaultUrl: string;
    static getNetworksInfo(): {
        [key in NetworkName]: NetworkInfo;
    };
    getNetworkUrl(flags: {
        [key in keyof typeof BaseCommand.flags]: any;
    }): string;
    getNetworkUrlAndFlag(flags: {
        [key in keyof typeof BaseCommand.flags]: any;
    }): [string, NetworkFlag];
}
export {};
