"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const cli_ux_1 = require("cli-ux");
class RandomAddressCommand extends command_1.Command {
    async run() {
        const { args } = this.parse(RandomAddressCommand);
        const { amount = '1', prefix = '' } = args;
        const amountNumber = parseInt(amount, 10);
        try {
            const { randomAddress } = await Promise.resolve().then(() => __importStar(require('../helpers/randomAddress')));
            randomAddress(amountNumber, prefix).forEach(({ address, privateKey }) => cli_ux_1.cli.styledJSON({ address, privateKey }));
        }
        catch (e) {
            this.error(e.message, { exit: 1 });
        }
    }
}
RandomAddressCommand.description = `Prints a random Ethereum checksum address with its Private Key.`;
RandomAddressCommand.args = [
    {
        name: 'amount',
        required: false,
        default: '1',
        description: 'Can be specified to generate a list of addresses.',
    },
    {
        name: 'prefix',
        required: false,
        default: '',
        description: 'Generates a random address with the given prefix.',
    },
];
RandomAddressCommand.examples = ['eth randomAddress 10 fd', 'eth randomAddress 2'];
RandomAddressCommand.aliases = ['ra'];
exports.RandomAddressCommand = RandomAddressCommand;
