"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cli_ux_1 = require("cli-ux");
const base_1 = require("../../base");
const flags_1 = require("../../flags");
class NopCommand extends base_1.BaseCommand {
    async run() {
        const { flags } = this.parse(NopCommand);
        let networkUrl;
        try {
            networkUrl = this.getNetworkUrl(flags);
            const { pk } = flags;
            const { generateNop } = await Promise.resolve().then(() => __importStar(require('../../helpers/generateNop')));
            const tx = await generateNop(networkUrl, pk);
            cli_ux_1.cli.styledJSON(tx);
        }
        catch (e) {
            this.error(e.message, { exit: 1 });
        }
    }
}
NopCommand.description = `Generates a transaction that does nothing with the given private key.`;
NopCommand.flags = Object.assign({}, base_1.BaseCommand.flags, { pk: Object.assign({}, flags_1.privateKeyFlag, { required: true }) });
NopCommand.examples = [
    'eth transaction:nop --pk 3daa79a26454a5528a3523f9e6345efdbd636e63f8c24a835204e6ccb5c88f9e',
    'ETH_CLI_PRIVATE_KEY=3daa79a26454a5528a3523f9e6345efdbd636e63f8c24a835204e6ccb5c88f9e eth transaction:nop',
];
NopCommand.aliases = ['tx:nop'];
exports.default = NopCommand;
