"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const fs = tslib_1.__importStar(require("fs"));
const web3_1 = tslib_1.__importDefault(require("web3"));
const utils_1 = require("./utils");
function deploy(url, privateKey, binPath) {
    const transactionConfirmationBlocks = 3;
    const options = {
        transactionConfirmationBlocks,
    };
    const web3 = new web3_1.default(new web3_1.default.providers.HttpProvider(url));
    privateKey = utils_1.add0x(privateKey);
    const { address } = web3.eth.accounts.wallet.add(privateKey);
    const data = utils_1.add0x(fs.readFileSync(binPath).toString());
    const Contract = web3.eth.Contract; // ts hack: transactionConfirmationBlocks is not a valid option
    const contract = new Contract([], undefined, options);
    const deploy = contract.deploy({ data });
    let receipt;
    return deploy
        .estimateGas({
        from: address,
    })
        .then((gas) => {
        process.stderr.write(`Estimated gas: ${gas}\n`);
        return deploy
            .send({
            from: address,
            gas,
        })
            .on('transactionHash', (tx) => {
            process.stderr.write(`TX: ${tx}\n`);
        })
            .on('confirmation', (confirmationNumber, transactionReceipt) => {
            receipt = transactionReceipt;
            process.stderr.write(`Confirmation ${confirmationNumber} of ${transactionConfirmationBlocks}\n`);
        })
            .then((contract) => ({ address: contract.options.address, receipt }));
    });
}
exports.deploy = deploy;
