"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ethereumjs_util_1 = require("ethereumjs-util");
const utils_1 = require("./utils");
function getMethods(abiPath) {
    let abi = utils_1.loadABI(abiPath);
    const methods = utils_1.extractMethodObjectsFromABI(abi).map(({ name, inputs }) => {
        const params = inputs.map((x) => x.type).join(',');
        const signature = `${name}(${params})`;
        const signatureHash = ethereumjs_util_1.keccak(signature)
            .toString('hex')
            .slice(0, 8);
        return { signature, signatureHash };
    });
    return methods;
}
exports.getMethods = getMethods;
