"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const erc20_json_1 = tslib_1.__importDefault(require("./abi/erc20.json"));
const erc721_json_1 = tslib_1.__importDefault(require("./abi/erc721.json"));
const ABI_META_DATA = [
    {
        name: 'ERC20',
        abiItem: erc20_json_1.default,
    },
    {
        name: 'ERC721',
        abiItem: erc721_json_1.default,
    },
];
exports.getAbiByName = (abiName) => {
    const abiInUpperCase = abiName.toUpperCase();
    const returnAbi = ABI_META_DATA.find(abi => abi.name === abiInUpperCase);
    if (returnAbi) {
        return returnAbi.abiItem;
    }
    return null;
};
exports.getStringAbiByName = (abiName) => {
    const abiObj = exports.getAbiByName(abiName);
    if (abiObj) {
        return JSON.stringify(abiObj);
    }
    return abiObj;
};
exports.getAbiList = () => {
    return ABI_META_DATA.map(item => {
        return item.name;
    });
};
