"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const web3_1 = tslib_1.__importDefault(require("web3"));
const utils_1 = require("./utils");
function sendTransaction(data, contractAddress, privateKey, url) {
    const web3 = new web3_1.default(new web3_1.default.providers.HttpProvider(url));
    privateKey = utils_1.add0x(privateKey);
    contractAddress = utils_1.add0x(contractAddress);
    const { address } = web3.eth.accounts.wallet.add(privateKey);
    return new Promise((resolve, reject) => {
        const tx = { from: address, data, to: contractAddress };
        web3.eth
            .estimateGas(tx)
            .then(gas => {
            tx.gas = gas;
            web3.eth
                .sendTransaction(tx)
                .on('transactionHash', resolve)
                .on('error', reject);
        })
            .catch(reject);
    });
}
exports.sendTransaction = sendTransaction;
